' SHCmdFile.VBS V1.03 (C) yoshioka.teruo@nifty.com 2005-07-23
' SHCmdFile is a shortcut to command with arguments.

Option Explicit
Dim wShell
Dim fso
Dim File
Dim Line
Dim Pos
Dim Key
Dim Command
Dim WorkingDirectory
Dim args
Dim k
Dim ExitCode
Dim fSubst
Dim fInteractive
Dim fWait
Dim WindowStyle
Const vbHide=0
Const vbNormalFocus=1
Const vbMinimizedFocus=2
Const vbMaximizedFocus=3
Const vbNormalNoFocus=4
Const vbMinimizedNoFocus=6

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

Set File=fso.OpenTextFile(WScript.Arguments(0))
Do While Not File.AtEndOfStream
  Line=File.ReadLine
  Pos=InStr(Line,"=")
  If Pos Then
    Key=UCase(Trim(Left(Line,Pos-1)))
    Line=Mid(Line,Pos+1)
    Select Case Key
    Case "COMMAND"
      If IsEmpty(Command) Then Command=Line
    Case "CURRENT","WORKINGDIRECTORY"
      Line=Trim(Line)
      If Left(Line,1)="""" Then Line=Replace(Line,"""","")
      WorkingDirectory=Line
    Case "WINDOWSTYLE"
      Line=Trim(Line)
      WindowStyle=CLng(Line)
    Case "INTERACTIVE"
      Line=Trim(Line)
      fInteractive=CLng(Line)
    Case "WAIT"
      Line=Trim(Line)
      fWait=CLng(Line)
    End Select
  End If
Loop
File.Close

If Command="" Then
  WScript.Echo "No Command Line!"
  WScript.Quit
End If

If IsNumeric(Command) Then
  File=WScript.Arguments(0)
  CreateObject("Shell.Application").NameSpace(Left(File,InStrRev(File,"\"))).ParseName(Mid(File,InStrRev(File,"\")+1)).InvokeVerb("open2")
  WScript.Quit
End If

If WorkingDirectory<>"" Then
  wShell.CurrentDirectory=WorkingDirectory
End If

If IsEmpty(WindowStyle) Then
  WindowStyle=vbNormalFocus
End If

ReDim args(WScript.Arguments.Count-1)

For k=1 To UBound(args)
  args(k)=WScript.Arguments(k)
Next

Pos=0
Line=Command
Command=""
Do
  Pos=InStr(Line,"%")
  If Pos=0 Then Exit Do
  Command=Command&Left(Line,Pos-1)
  k=Mid(Line,Pos+1,1)
  If IsNumeric(k) And Not IsNumeric(Mid(Line&"?",Pos+2,1)) Then
    fSubst=True
    k=CLng(k)
    If 0<k And k<WScript.Arguments.Count Then
      Command=Command&args(k)
    End If
    Line=Mid(Line,Pos+2)
  ElseIf k="%" Then
    Command=Command&Mid(Line,Pos,2)
    Line=Mid(Line,Pos+2)
  Else
    Command=Command&Mid(Line,Pos,1)
    Line=Mid(Line,Pos+1)
  End If
Loop
Command=Command&Line
If Not fSubst Then
  For k=1 To UBound(args)
    If InStr(args(k)," ") Then args(k)="""" & args(k) & """"
  Next
  args(0)=Command
  Command=Join(args)
End If

If fInteractive=1 Then
  If MsgBox("s܂H"&vbLf&vbLf&"'"&Command&"'"&vbLf&vbLf&"WindowStyle="&WindowStyle,vbOkCancel+vbQuestion,WScript.ScriptName)<>vbOK Then
    WScript.Quit
  End If
ElseIf fInteractive=2 Then
  Command=InputBox("s܂H"&vbLf&vbLf&"'"&Command&"'"&vbLf&vbLf&"WindowStyle="&WindowStyle,WScript.ScriptName,Command)
  If Command="" Then
    WScript.Quit
  End If
End If

'On Error Resume Next
ExitCode=wShell.Run(Command,WindowStyle,fWait)
If Err.Number<>0 Or fWait<>0 Then
  WScript.Echo Command&vbLf&"ExitCode="&ExitCode&vbLf&"Err.Number="&Err&vbLf&"Err.Description="&Err.Description
End If
