' SHCmdFileUnRegister.VBS V1.03 (C) yoshioka.teruo@nifty.com 2005-07-23
' SHCmdFileUnRegister.VBS unregisters SHCmdFile class for link function.
' Usage: Start SHCmdFileUnRegister.VBS

Option Explicit
Dim wShell
Dim ans
Dim arg

Dim sFolder
sFolder=WScript.ScriptFullName
sFolder=Left(sFolder,InStrRev(sFolder,"\"))

Dim pFolder
pFolder=WScript.FullName
pFolder=Left(pFolder,InStrRev(pFolder,"\"))
If LCase(Right(pFolder,9))="\command\" Then
  pFolder=Left(pFolder,Len(pFolder)-8)
End If

Dim args
args=Array(_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open2\ddeexec\NoActivateHandler" _
),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open2\ddeexec\Application\" _
),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open2\ddeexec\Topic\" _
),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open2\ddeexec\" _
),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open2\command\" _
),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open2\" _
),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open\command\",_
"explorer.exe",_
"REG_SZ"),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open\ddeexec\",_
"[ShellFile(""%1"",""%1"",%S)]",_
"REG_SZ"),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open\ddeexec\NoActivateHandler",_
"",_
"REG_SZ"),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open\ddeexec\Application\",_
"Folders",_
"REG_SZ"),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\open\ddeexec\Topic\",_
"AppProperties",_
"REG_SZ"),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\edit\command\" _
),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\Shell\edit\" _
),_
Array(_
"HKEY_CLASSES_ROOT\SHCmdFile\ShellEx\DropHandler\" _
))

Set wShell=CreateObject("WScript.Shell")

For Each arg In args
  Register(arg)
Next
WScript.Quit

Sub Register(arg)
Dim Prev
Prev=RegRead(arg(0))
If Err And Err<>-2147024894 Then WScript.Echo Err,Err.Description
If Err=-2147024894 Then Prev="(empty)"
If UBound(arg) Then
  If Prev=arg(1) Then Exit Sub
  ans=MsgBox("KEY" & vbTAB & arg(0) & vbLf &_
             "OLD" & vbTAB & "'" & Prev & "'" & vbLf &_
             "NEW" & vbTAB & "'" & arg(1) & "'" & vbLf ,_ 
              vbYesNoCancel+vbDefaultButton1,"Yes - Change / No - Skip / Cancel - Exit.")
  If ans=vbCancel Then WScript.Quit
  If ans=vbNo Then Exit Sub
  Call RegWrite(arg(0),arg(1),arg(2))
  If Err And Err<>-2147024894 Then WScript.Echo Err,Err.Description
Else
  ans=MsgBox("KEY" & vbTAB & arg(0) & vbLf &_
             "OLD" & vbTAB & "'" & Prev & "'" & vbLf &_
             "NEW" & vbTAB & "DELETE" & vbLf ,_ 
              vbYesNoCancel+vbDefaultButton1,"Yes - Change / No - Skip / Cancel - Exit.")
  If ans=vbCancel Then WScript.Quit
  If ans=vbNo Then Exit Sub
  Call RegDelete(arg(0))
  If Err And Err<>-2147024894 Then WScript.Echo Err,Err.Description
End If
End Sub

Function RegRead(KeyName)
On Error Resume Next
RegRead=wShell.RegRead(keyName)
End Function

Sub RegWrite(KeyName,KeyValue,KeyType)
On Error Resume Next
Call wShell.RegWrite(keyName,KeyValue,KeyType)
End Sub

Sub RegDelete(KeyName)
On Error Resume Next
Call wShell.RegDelete(keyName)
End Sub

